.setcallreg r0.w0
.origin 0
.entrypoint START

#include "stddef.hp"
#include "ircommander.hp"

START:
	IIC:
		// Activeer de I2C-bus
		LBCO temp, CONST_PRUCFG, 4, 4
		CLR  temp, temp, 4
		SBCO temp, CONST_PRUCFG, 4, 4

		ZERO &r0, 4*16 // Leeg registers 0 t/m 15
		ISHI previous, input, P8_15


	SHORTLOOP: //duur: 5*(5*2^shortcycle) ns
		INC  shortcnt
		ISHI temp, input, P8_15
		INC  total, temp
		QBGT SHORTLOOP, shortcnt, 1<<shortcycle


	CHECKVALUE: //duur: 5*(5*2^shortcycle+6) ns
		ZERO &shortcnt, 4
		INC  timer, 5*(5*(1<<shortcycle)+6)

		LSR  current, total, (shortcycle-1)
		ZERO &total, 4
		MIN  current, current, 1 //de maximale waarde voor total leidt tot current=10b i.p.v. current=1b
		QBEQ SHORTLOOP, current, previous


	//duur: niet meer relevant op deze schaal, dus deze code tellen we niet mee
	NEWVALUE:
		MOV  previous, current
		MOV  temp, 1500000
		QBGT ENDIF1, timer, temp
			CALL STARTSIGNAL
		ENDIF1:
		MOV  temp, 1000000
		QBGT ENDIF2, timer, temp
			CALL LONGSIGNAL
		ENDIF2:
		MOV  temp, 1000000
		QBLE ENDIF3, timer, temp
			CALL SHORTSIGNAL
		ENDIF3:
		ZERO &timer, 4
		QBA  SHORTLOOP


STARTSIGNAL:
	// Voor debugging:
	CLR  P8_12
	ZERO &lowbits, 8
	ZERO &nextbit, 4
	RET

SHORTSIGNAL:
	QBEQ ENDIF4, current, 0
		QBGT ENDIF5, nextbit, 48
				// Hoog, kort signaal en 48 bits ontvangen: pakket klaar
				// Voor debugging:
				SET  P8_12
				LBCO write_pos, CONST_PRUDRAM, 0, 4
				LBCO read_pos, CONST_PRUDRAM, 4, 4
				INC  write_pos
				AND  write_pos, write_pos, (1<<8)-1
				
				// Kijk of de buffer vol zit
				QBEQ ENDIF6, read_pos, write_pos
					LSL  offset, write_pos, 3
					INC  offset, 8
					SBCO lowbits, CONST_PRUDRAM, offset, 8
					SBCO write_pos, CONST_PRUDRAM, 0, 4
				ENDIF6:
				
				// Interrupt naar de CPU (ongeacht de status van de buffer)
				MOV R31.b0, PRU0_ARM_INTERRUPT+16

				ZERO &nextbit, 4
		ENDIF5:
		
		// Hoog, kort signaal: doe niets
		RET
	ENDIF4:

	// Laag, kort signaal: 0 wegschrijven
	add_bit 0
	RET

LONGSIGNAL:
	QBEQ ENDIF7, current, 0
		// Hoog, lang signaal: doe niets
		RET
	ENDIF7:
	
	// Laag, lang signaal: 1 wegschrijven
	add_bit 1
	RET
