.origin 0
.entrypoint START

#include "stddef.hp"
#define P8_11 r30.t15
#define P8_12 r30.t14
#define P8_15 15
#define P8_16 14

#define shortcnt r1
#define timer    r2
#define length   r3
#define previous r4
#define current  r5
#define total    r6
#define temp     r10
#define output   r30
#define input    r31

// Lengte van de cyclus in 2^n om een gemiddelde uitslag te bepalen
#define shortcycle 3

.macro INC
.mparam target, amount=1
	ADD target, target, amount
.endm

.macro ISHI
.mparam target, source, bit
	LSR  target, source, bit
	AND  target, target, 1
.endm

IIC:
	// Activeer de I2C-bus
	LBCO r0, CONST_PRUCFG, 4, 4
	CLR  r0, r0, 4
	SBCO r0, CONST_PRUCFG, 4, 4

START:
	ZERO &r0, 4*11 // Leeg registers 0 t/m 10
	ISHI previous, input, P8_15
	
	// Zet een 0 in de array
	INC  length
	LSL  temp, length, 2
	SBCO r0, CONST_PRUDRAM, temp, 4
	SBCO length, CONST_PRUDRAM, 0, 4
	
	
SHORTLOOP: //duur: 5*(5*2^shortcycle) ns
	INC  shortcnt
	ISHI temp, input, P8_15
	INC  total, temp
	QBGT SHORTLOOP, shortcnt, 1<<shortcycle
	
LONGLOOP: //duur: 5*(5*2^shortcycle+6) ns
	ZERO &shortcnt, 4
	INC  timer, 5*(5*(1<<shortcycle)+6)
	
	LSR  current, total, (shortcycle-1)
	ZERO &total, 4
	MIN  current, current, 1 //de maximale waarde voor total leidt tot current=10b i.p.v. current=1b
	QBEQ SHORTLOOP, current, previous
	
NEWVALUE: //duur: timer+5*15 ns
	MOV  previous, current
	INC  timer, 5*15
	LSL  temp, current, 30
	OR   timer, timer, temp
	
	//debug naar LED
	QBBS SETHI, current.t0
	SETLO:
		SET  P8_11
		QBA  ENDIF
	SETHI:
		CLR  P8_11
		QBA  ENDIF
	ENDIF:

	INC  length
	LSL  temp, length, 2
	SBCO timer, CONST_PRUDRAM, temp, 4
	SBCO length, CONST_PRUDRAM, 0, 4
	ZERO &timer, 4
	QBA  SHORTLOOP
