.setcallreg r0.w0
.origin 0
.entrypoint START

#include "stddef.hp"
#include "read_signal.hp"

START:
	IIC:
		// Activeer de I2C-bus
		LBCO temp, CONST_PRUCFG, 4, 4
		CLR  temp, temp, 4
		SBCO temp, CONST_PRUCFG, 4, 4

		ZERO &r0, 4*16 // Leeg registers 0 t/m 15
		ISHI previous, input, P8_15


	SHORTLOOP: //duur: 5*(5*2^shortcycle) ns
		INC  shortcnt
		ISHI temp, input, P8_15
		INC  total, temp
		QBGT SHORTLOOP, shortcnt, 1<<shortcycle


	CHECKVALUE: //duur: 5*(5*2^shortcycle+6) ns
		ZERO &shortcnt, 4
		INC  timer, 5*(5*(1<<shortcycle)+6)

		LSR  current, total, (shortcycle-1)
		ZERO &total, 4
		MIN  current, current, 1 //de maximale waarde voor total leidt tot current=10b i.p.v. current=1b
		QBEQ SHORTLOOP, current, previous


	NEWVALUE:
		MOV  previous, current
		MOV  temp, 1500000
		QBGT ENDIF1, timer, temp
			CALL STARTSIGNAL
		ENDIF1:
		MOV  temp, 1000000
		QBGT ENDIF2, timer, temp
			CALL LONGSIGNAL
		ENDIF2:
		MOV  temp, 1000000
		QBLE ENDIF3, timer, temp
			CALL SHORTSIGNAL
		ENDIF3:
		ZERO &timer, 4
		QBA  SHORTLOOP


STARTSIGNAL:
	SET  P8_12
	ZERO &lowbits, 8
	ZERO &nextbit, 4
	RET

SHORTSIGNAL:
	QBEQ ENDIF4, current, 0
		QBGT ENDIF5, nextbit, 48
				// Hoog signaal, 48 bits geschreven
				LBCO length, CONST_PRUDRAM, 0, 4
				AND  length, length, (1<<8)-1
				LSL  offset, length, 3
				INC  offset, 4
				INC  length
				SBCO lowbits, CONST_PRUDRAM, offset, 8
				SBCO length, CONST_PRUDRAM, 0, 4
				
				ZERO &nextbit, 4
		ENDIF5:
		RET
	ENDIF4:

	// Laag, kort signaal, 0 wegschrijven
	add_bit 0
	RET

LONGSIGNAL:
	QBEQ ENDIF7, current, 0
		RET
	ENDIF7:
	
	// Laag, lang signaal, 1 wegschrijven
	add_bit 1
	RET
