#include <stdio.h>
#include <unistd.h>
#include <prussdrv.h>
#include <pruss_intc_mapping.h>

tpruss_intc_initdata pruss_intc_initdata = PRUSS_INTC_INITDATA;

int main (void)
{
	prussdrv_init();

	//Open de PRU zonder uitgaande events en laad de mmaps
	if (prussdrv_open(PRU_EVTOUT_0))
	{
		printf("prussdrv_open open failed\n");
		return 1;
	}

	//Start de interrupt controller
	prussdrv_pruintc_init(&pruss_intc_initdata);

	//Schakel mogelijke interrupts uit
	prussdrv_pru_clear_event(PRU_EVTOUT_0, PRU0_ARM_INTERRUPT);

	//Zet de PRU uit en stop de driver
	prussdrv_pru_disable(PRU0); 
	prussdrv_exit();
	
	return(0);
}
